<template>
    <el-dropdown ref="userCenterPopup" trigger="click" popper-class="dropdown-user-center" class="mr-4" placement="bottom-start">
        <div class="mr-2 flex flex-col gap-1" @click="showUserPopupCenter">
            <div class="w-8 h-[4px] bg-white rounded-[10px]"></div>
            <div class="w-8 h-[4px] bg-white rounded-[10px]"></div>
            <div class="w-8 h-[4px] bg-white rounded-[10px]"></div>
        </div>
        <template #dropdown>
            <el-dropdown-menu>
                <div class="w-[264px]">
                    <div class="bg-background5 h-[330px] relative border-0 rounded-lg">
                        <div v-if="!auth" class="absolute top-0 right-0 left-0 bottom-0 bg-[rgba(0,0,0,0.5)] rounded-lg backdrop-blur-[3px]"></div>
                        <div class="h-[264px] flex justify-center items-center p-4">
                            <div class="grid grid-cols-3 gap-2">
                                <nuxt-link
                                    v-for="tab in tabsForDisplay"
                                    :key="tab.to"
                                    :to="tab.to"
                                    @click="hideUserPopupCenter"
                                >
                                    <div class="w-[72px] h-[72px] bg-background2 rounded-lg flex justify-center items-center">
                                        <div class="p-1 w-full">
                                            <div class="flex justify-center">
                                                <SvgIcon :svg-name="tab.icon" class="w-5 h-5"/>
                                            </div>
                                            <div class="w-full flex justify-center">
                                                <p class="mt-1 truncate text-xs ">{{ $t(tab.label) }}</p>
                                            </div>
                                        </div>
                                    </div>
                                </nuxt-link>                
                            </div>
                        </div>
                        <div class="h-[66px] flex justify-center items-center logout-modal cursor-pointer" @click="onLogout">
                            <div class="bg-secondary font-bold w-[232px] h-8 rounded-lg flex justify-center items-center text-white">
                                {{ $t('logout') }}
                            </div>
                        </div>
                    </div>
                    <div class="h-[330px] absolute w-full top-0 right-0" :class="auth && 'bg-background5'" v-if="!auth">
                        <div class="h-[282px] flex justify-center items-center">
                        <div class="flex flex-col">
                            <div class="flex justify-center">
                                <img :src="getAssetImage('assets/theme/bk8/desktop/icons/Login.png')" alt="">
                            </div>
                                <div class="mt-4 w-[232px] text-center">
                                    <p class="">
                                        {{ $t('please_login_before_using_the_user_center_function') }}
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="h-[48px] flex justify-center items-start">
                            <nuxt-link to="/login" @click="hideUserPopupCenter">
                                <div class="bg-secondary font-bold w-[232px] h-8 rounded-lg flex justify-center items-center text-white">
                                    <p>{{ $t('login') }}</p>
                                </div>
                            </nuxt-link>
                        </div>
                    </div>
                </div>
            </el-dropdown-menu>
        </template>
    </el-dropdown>          
</template>

<script setup lang="ts">
import type { DropdownInstance } from 'element-plus';
import useMenu from "@/composables/useMenu";
import { store } from '~~/store';
const { logout, isLoading, isReferralV2Enabled } = useHeaderComponent();
const {
    isCashPlayer,
    isShowDepositWithdrawal,
    isShowPromotion,
} = useMenu();
const { getAssetImage } = commonHelper;
const auth = computed(() => store.state.auth);
const userCenterPopup = ref<DropdownInstance>();
const showUserPopupCenter = () =>  {
    if (!userCenterPopup.value) return
    userCenterPopup.value.handleOpen();
}
const hideUserPopupCenter = () =>  {
    if (!userCenterPopup.value) return
    userCenterPopup.value.handleClose();
}


const onLogout = () => {
    logout();
    hideUserPopupCenter();
}

const route = useRoute();
const routePath = computed(() => route.path);
const tabsForDisplay = computed(() => {
    const tabs = [
        {
            to: `${routePath.value}?uc=/deposit`,
            label: "deposit",
            icon: "icon-deposit",
            display: isCashPlayer.value && isShowDepositWithdrawal.value,
        },
        {
            to: `${routePath.value}?uc=/withdrawal`,
            label: "withdrawal",
            icon: "icon-withdraw",
            display: isCashPlayer.value && isShowDepositWithdrawal.value,
        },
        { to: `${routePath.value}?uc=/wallet`, label: "wallet", icon: "icon-wallet", display: true },
        { to: `${routePath.value}?uc=/account`, label: "account", icon: "icon-account", display: true },
        {
            to: `${routePath.value}?uc=/transaction-history`,
            label: "statement",
            icon: "icon-transaction",
            display: true,
        },
        {
            to: `${routePath.value}?uc=/bet-history`,
            label: "bet_history",
            icon: "icon-bethistory",
            display: true,
        },
        {
            to: `${routePath.value}?uc=/my-promotion`,
            label: "promotion",
            icon: "icon-promotion",
            display: isShowPromotion.value,
        },
        {
            to: `${routePath.value}?uc=/referral-v2`,
            label: "referral",
            icon: "icon-referral",
            display: isReferralV2Enabled.value,
        },
    ];
    if (!auth.value) return tabs;
    return tabs.filter((tab) => tab.display);
}
);
</script>

<style lang="scss">
.dropdown-user-center {
    border: unset !important;
    border-radius: 12px;
    .el-dropdown-menu {
        padding: 0;
        border-radius: 24px;
    }
    .el-popper__arrow::before {
        display: none;
    }
}
</style>

<style scoped lang="scss">

.logout-modal {
    border-top: 1px solid var(--border);
}
</style>